'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setRouteComponents = exports.setPreviousPath = exports.removeComponent = exports.addComponent = exports.SET_ROUTE_COMPONENTS = exports.SET_PREVIOUS_PATH = exports.REMOVE_COMPONENT = exports.ADD_COMPONENT = undefined;

var _cuid = require('cuid');

var _cuid2 = _interopRequireDefault(_cuid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ADD_COMPONENT = exports.ADD_COMPONENT = '@@relocation/ADD_COMPONENT';
var REMOVE_COMPONENT = exports.REMOVE_COMPONENT = '@@relocation/REMOVE_COMPONENT';
var SET_PREVIOUS_PATH = exports.SET_PREVIOUS_PATH = '@@relocation/SET_PREVIOUS_PATH';
var SET_ROUTE_COMPONENTS = exports.SET_ROUTE_COMPONENTS = '@@relocation/SET_ROUTE_COMPONENTS';

var addComponent = exports.addComponent = function addComponent(_ref) {
  var type = _ref.type;
  var props = _ref.props;
  var _ref$id = _ref.id;
  var id = _ref$id === undefined ? (0, _cuid2.default)() : _ref$id;
  return {
    type: ADD_COMPONENT,
    payload: { id: id, type: type, props: props }
  };
};

var removeComponent = exports.removeComponent = function removeComponent(id) {
  return { type: REMOVE_COMPONENT, payload: id };
};

var setPreviousPath = exports.setPreviousPath = function setPreviousPath(path) {
  return {
    type: SET_PREVIOUS_PATH,
    payload: path
  };
};

var setRouteComponents = exports.setRouteComponents = function setRouteComponents(components) {
  return {
    type: SET_ROUTE_COMPONENTS,
    payload: components
  };
};
//# sourceMappingURL=action.js.map