'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactRedux = require('react-redux');

var _selector = require('./selector');

var _action = require('./action');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Create a higher-order wrapper which provides an array of components to render
 * to its wrapped instance.
 *
 * @param {Object|Function} rawRenderMap An object with component type/render
 * function key value pairs or a function returning such an object.
 * @param {Object|Function} rawConfig An object or a function returing such an
 * object.
 * @returns {Function} Higher-order component wrapper.
 */
exports.default = function (rawRenderMap) {
  var rawConfig = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  return function (WrappedComponent) {
    var Connect = function (_Component) {
      _inherits(Connect, _Component);

      function Connect() {
        _classCallCheck(this, Connect);

        return _possibleConstructorReturn(this, (Connect.__proto__ || Object.getPrototypeOf(Connect)).apply(this, arguments));
      }

      _createClass(Connect, [{
        key: 'navigateToPath',
        value: function navigateToPath(path) {
          var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

          var _ref$useHistoryBack = _ref.useHistoryBack;
          var useHistoryBack = _ref$useHistoryBack === undefined ? true : _ref$useHistoryBack;

          // Check for the react-router context.
          if (!this.context.router) {
            return;
          }

          var previousPath = this.props.___relocation___.previousPath;

          // The `useHistoryBack` option will trigger the use of the `goBack` method
          // instead of `push` in an effort to keep the if the requested path is
          // equal to the previous path.
          //
          // This is useful in scenraios where component that is displayed in
          // response to a route change is considered dismissed or completed on
          // removal.

          if (useHistoryBack && path === previousPath) {
            this.context.router.goBack();
          } else {
            this.context.router.push(path);
          }
        }
      }, {
        key: 'removeComponent',
        value: function removeComponent(id /* , options */) {
          return this.props.dispatch((0, _action.removeComponent)(id));
        }
      }, {
        key: 'render',
        value: function render() {
          var _this2 = this;

          var _props$___relocation_ = this.props.___relocation___;
          var components = _props$___relocation_.components;
          var renderMap = _props$___relocation_.renderMap;


          var assignRender = function assignRender(component) {
            return _extends({}, component, {
              render: renderMap[component.type]
            });
          };

          var inRenderMap = function inRenderMap(component) {
            return typeof renderMap[component.type] === 'function';
          };

          var assignRemoveHandler = function assignRemoveHandler(component) {
            var removeHandler = null;

            if (typeof component.remove === 'function') {
              // The component object remove property is already a function.
              // We don't want to override this behavior.
              removeHandler = component.remove;
            } else if (component.remove === undefined || component.remove) {
              // The component object does not have a `remove` property, or it has
              // a truthy value that is not a function. Either case indicates that
              // it should use the default remove handler.
              removeHandler = function removeHandler(options) {
                return _this2.removeComponent(component.id, options);
              };
            }

            var pathRemoveHandler = null;

            if (typeof component.removePath === 'string') {
              // Create a function that will change the history state when removing
              // the component.
              pathRemoveHandler = function pathRemoveHandler(options) {
                return _this2.navigateToPath(component.removePath, options);
              };
            }

            if (pathRemoveHandler && removeHandler) {
              // A remove handler function and a
              return _extends({}, component, {
                remove: function remove(options) {
                  pathRemoveHandler(options);
                  return removeHandler(options);
                }
              });
            }

            if (pathRemoveHandler && !removeHandler) {
              return _extends({}, component, {
                remove: pathRemoveHandler
              });
            }

            if (!pathRemoveHandler && removeHandler !== component.remove) {
              return _extends({}, component, {
                remove: removeHandler
              });
            }

            // `!pathRemoveHandler && removeHandler === component.remove` is true.
            // This means `remove` was set and `removePath` was not set on the
            // component object. No modification is necessary.
            return component;
          };

          var mergedProps = _extends({}, this.props, {
            components: components
            // Assign render functions.
            .map(assignRender)
            // Remove components not included in the render function map.
            .filter(inRenderMap)
            // Assign remove handler functions.
            .map(assignRemoveHandler)
          });

          return (0, _react.createElement)(WrappedComponent, mergedProps);
        }
      }]);

      return Connect;
    }(_react.Component);

    Connect.propTypes = {
      dispatch: _react.PropTypes.func.isRequired,
      ___relocation___: _react.PropTypes.shape({
        components: _util.componentsShape.isRequired,
        previousPath: _react.PropTypes.string.isRequired,
        config: _react.PropTypes.object.isRequired,
        renderMap: _util.renderMapShape.isRequired
      }).isRequired
    };
    Connect.contextTypes = {
      router: _react.PropTypes.object
    };


    Connect.displayName = 'Relocation(' + (0, _util.getDisplayName)(WrappedComponent) + ')';

    var mapState = function mapState(state, props) {
      var config = typeof rawConfig === 'function' ? rawConfig(props) : rawConfig;

      var renderMap = typeof rawRenderMap === 'function' ? rawRenderMap(props) : rawRenderMap;

      var getRelocationState = config.getRelocationState;


      var selectorProps = getRelocationState ? _extends({ getRelocationState: getRelocationState }, props) : props;

      return {
        // Put everything in a ___relocation___ namespace to avoid possible
        // conflict with existing props.
        ___relocation___: {
          components: (0, _selector.getMergedComponents)(state, selectorProps),
          previousPath: (0, _selector.getPreviousPath)(state, selectorProps),
          config: config,
          renderMap: renderMap
        }
      };
    };

    return (0, _reactRedux.connect)(mapState)((0, _hoistNonReactStatics2.default)(Connect, WrappedComponent));
  };
};
//# sourceMappingURL=connect.js.map