'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _reactRedux = require('react-redux');

var _invariant = require('fbjs/lib/invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _action = require('./action');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * [description]
 * @param {Function} formatPattern - The React Router `formatPattern` function.
 * @returns {[type]}              [description]
 */
exports.default = function (formatPattern) {
  (0, _invariant2.default)(typeof formatPattern === 'function', 'The `formatPattern` function from `react-redux` must be provided. ' + 'Add `import {formatPattern} from "react-router"` and add it as the ' + 'argument to your call to `createRelocationRouter`.');

  var finalFormatPattern = typeof formatPattern === 'function' ? formatPattern : function (path) {
    return path;
  };

  var RelocationRouter = function (_Component) {
    _inherits(RelocationRouter, _Component);

    function RelocationRouter() {
      _classCallCheck(this, RelocationRouter);

      return _possibleConstructorReturn(this, (RelocationRouter.__proto__ || Object.getPrototypeOf(RelocationRouter)).apply(this, arguments));
    }

    _createClass(RelocationRouter, [{
      key: 'componentWillMount',


      // Use `componentWillMount` over `constructor` when calling `dispatch`.
      // see: https://github.com/reactjs/react-redux/issues/129
      value: function componentWillMount() {
        this.updateRouteComponents(this.props);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.updatePreviousPath(nextProps);
        this.updateRouteComponents(nextProps);
      }
    }, {
      key: 'updateRouteComponents',
      value: function updateRouteComponents(props) {
        var routes = props.routes;
        var params = props.params;
        var location = props.location;
        var dispatch = this.props.dispatch;


        if (this.routes === params && this.prams === params) {
          return;
        }

        this.routes = routes;
        this.params = params;

        var join = function join(base, path) {
          return base + (path && !/\/$/.test(base) ? '/' : '') + path;
        };

        var getFormattedPathName = function getFormattedPathName(i) {
          var path = '';

          for (var current = i; current >= 0; current--) {
            var route = routes[current];

            if (route && route.path) {
              path = join(route.path, path);
              if (/^\//.test(path)) {
                return finalFormatPattern(path, params);
              }
            }
          }

          return null;
        };

        var components = routes.reduce(function (components, route, i) {
          var relocation = route.relocation;


          if (relocation) {
            components.push(_extends({
              // Use the formatted path that matched as the default id.
              id: getFormattedPathName(i),

              // Merge component props with redux-router props.
              props: _extends({}, relocation.props, {
                location: location,
                params: params
              })

            }, typeof relocation === 'string' ? { type: relocation } : relocation, {

              removePath: relocation.removePath !== undefined ? relocation.removePath : getFormattedPathName(i - 1)
            }));
          }

          return components;
        }, []);

        dispatch((0, _action.setRouteComponents)(components));
      }
    }, {
      key: 'updatePreviousPath',
      value: function updatePreviousPath(nextProps) {
        var _props = this.props;
        var previousPath = _props.location.pathname;
        var dispatch = _props.dispatch;
        var currentPath = nextProps.location.pathname;


        if (previousPath && previousPath !== currentPath) {
          dispatch((0, _action.setPreviousPath)(previousPath));
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var children = this.props.children;


        return _react.Children.only(children);
      }
    }]);

    return RelocationRouter;
  }(_react.Component);

  RelocationRouter.propTypes = {
    routes: _react.PropTypes.array.isRequired,
    params: _react.PropTypes.object.isRequired,
    location: _react.PropTypes.object.isRequired,
    children: _react.PropTypes.element.isRequired,
    dispatch: _react.PropTypes.func.isRequired
  };


  return (0, _reactRedux.connect)()(RelocationRouter);
};
//# sourceMappingURL=router.js.map