'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMergedComponents = exports.getPreviousPath = exports.getRouteComponents = exports.getComponents = exports.getRelocation = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _findIndex = require('core-js/library/fn/array/find-index');

var _findIndex2 = _interopRequireDefault(_findIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var getRelocation = exports.getRelocation = function getRelocation(state, props) {
  return props && props.getRelocationState ? props.getRelocationState(state, props) : state.relocation;
};

var getComponents = exports.getComponents = function getComponents(state, props) {
  return getRelocation(state, props).components;
};

var getRouteComponents = exports.getRouteComponents = function getRouteComponents(state, props) {
  return getRelocation(state, props).routeComponents;
};

var getPreviousPath = exports.getPreviousPath = function getPreviousPath(state, props) {
  return getRelocation(state, props).previousPath;
};

var getMergedComponents = exports.getMergedComponents = function getMergedComponents(state, props) {
  return [].concat(_toConsumableArray(getRouteComponents(state, props)), _toConsumableArray(getComponents(state, props))).reduce(function (components, component) {
    var index = (0, _findIndex2.default)(components, function (_ref) {
      var id = _ref.id;
      return id === component.id;
    });

    if (index === -1) {
      components.push(component);
      return components;
    }

    var existing = components[index];

    components[index] = _extends({}, existing, component, existing.props && component.props ? {
      props: _extends({}, existing.props, component.props)
    } : null);

    return components;
  }, []);
};
//# sourceMappingURL=selector.js.map